<template lang="pug">
  .actions(:class="{ horizontal: isHorizontal }")
    nuxt-link.logo(to="/creator/dashboard")
      .logo-pic
    .actions-container
      .action(
        v-bind:class="{ active: currentAction === action.name && leftSidebarExpanded, search: getSearchTotal(action.name) && searchQuery }"
        v-for="action in actions"
        v-on:click="select(action)"
        v-tooltip:right="action.name.charAt(0).toUpperCase() + action.name.slice(1)"
      )
        .icon(v-html="$icons[action.name]" v-bind:style="action.iconStyle")
        .icon-hover(v-html="$icons[action.name + 'Hover']" v-bind:style="action.iconStyle")
</template>

<script>
import { mapState } from 'vuex'
import itemsService from '../services/items/common'

export default {
  name: 'Actions',
  props: {
    isHorizontal: {
      default: false,
      type: Boolean
    }
  },
  data () {
    return {
      ACTION_OBJECTS: itemsService.ACTION_OBJECTS,
      ACTION_MODELS: itemsService.ACTION_MODELS,
      ACTION_BACKGROUNDS: itemsService.ACTION_BACKGROUNDS,
      ACTION_TEXT: itemsService.ACTION_TEXT,
      actions: [
        {
          name: itemsService.ACTION_MODELS,
          iconStyle: { width: '14px', height: '18px' }
        },
        {
          name: itemsService.ACTION_OBJECTS,
          iconStyle: { width: '17px', height: '18px' }
        },
        {
          name: itemsService.ACTION_BACKGROUNDS,
          iconStyle: { width: '20px', height: '17px' }
        },
        {
          name: itemsService.ACTION_TEXT,
          iconStyle: { width: '14px', height: '19px' }
        },
        {
          name: itemsService.ACTION_UPLOADS,
          iconStyle: { width: '20px', height: '20px' }
        }
      ]
    }
  },
  computed: {
    ...mapState({
      currentAction: state => state.editor.currentAction,
      leftSidebarExpanded: state => state.editor.leftSidebarExpanded,
      searchQuery: state => state.editor.searchQuery,
      searchModels: state => state.editor.searchModels,
      searchObjects: state => state.editor.searchObjects,
      searchBackgrounds: state => state.editor.searchBackgrounds
    })
  },
  methods: {
    select (action) {
      this.$emit('select-action', action)
      this.$store.dispatch('setCurrentAction', action.name)
    },
    getSearchTotal (actionName) {
      const fieldName = `search${actionName.charAt(0).toUpperCase() + actionName.slice(1)}`
      if (this[fieldName]) {
        return this[`search${actionName.charAt(0).toUpperCase() + actionName.slice(1)}`].total
      }
      return 0
    }
  }
}
</script>

<style lang="scss" scoped>
@import '../assets/css/mixins';
@import '../assets/css/variables';

.actions {
  display: flex;
  flex-direction: column;
  position: relative;
  z-index: 20;
  background-color: $sidebar-background-color;

  .logo {
    position: relative;
    width: 56px;
    height: 56px;
    text-decoration: none;
    border-bottom: 1px solid rgba(255, 255, 255, 0.05);
    .logo-pic {
      position: relative;
      top: 16px;
      left: 16px;
      width: 24px;
      height: 24px;
      color: #fff;
      border: 2px solid #fff;
      &:after {
        content: '';
        position: absolute;
        top: calc(50% - 6px);
        left: calc(50% - 6px);
        width: 12px;
        height: 12px;
        border: 2px solid currentColor;
        border-radius: 50%;
      }
    }
  }

  .actions-container {
    display: flex;
    flex-direction: column;
    align-items: center;
    padding-top: 8px;

    .action {
      width: 32px;
      height: 32px;
      position: relative;
      display: flex;
      align-items: center;
      justify-content: center;
      border-radius: 20px;
      margin: 8px;
      cursor: pointer;

      .icon {
        width: 16px;
        margin: 0 auto;

        &-hover {
          display: none;
        }
      }

      &:hover, &.active {
        background-color: rgba(255, 255, 255, 0.1);
        @include delay()
      }

      &.search::after {
        content: '';
        width: 5px;
        height: 5px;
        position: absolute;
        top: 13px;
        left: -4px;
        background-color: #FF3A3A;
        border-radius: 100%;
      }

      &.active {
        .icon {
          display: none;
        }

        .icon-hover {
          display: block;
        }

        &::after {
          display: none;
        }
      }
    }
  }

  &.horizontal {
    flex-direction: row;

    .actions-container {
      flex-direction: row;
      padding-top: 0;
    }
  }
}
</style>
